﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;
using Telerik.Windows.Controls;

namespace PhoneApp12
{
    public class PullToRefreshBehavior : Behavior<RadDataBoundListBox>
    {



        public ICommand RefreshCommand
        {
            get { return (ICommand)GetValue(RefreshCommandProperty); }
            set { SetValue(RefreshCommandProperty, value); }
        }

        // Using a DependencyProperty as the backing store for RefreshCommand.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty RefreshCommandProperty =
            DependencyProperty.Register("RefreshCommand", typeof(ICommand), typeof(PullToRefreshBehavior), new PropertyMetadata(null));



        protected override void OnAttached()
        {
            base.OnAttached();

            this.AssociatedObject.IsPullToRefreshEnabled = true;
            this.AssociatedObject.RefreshRequested += AssociatedObject_RefreshRequested;
        }

        protected override void OnDetaching()
        {
            this.AssociatedObject.RefreshRequested -= AssociatedObject_RefreshRequested;

            base.OnDetaching();
        }

        void AssociatedObject_RefreshRequested(object sender, EventArgs e)
        {
            if (this.RefreshCommand != null && this.RefreshCommand.CanExecute(null))
            {
                Action dataLoadingComplete = () => this.AssociatedObject.StopPullToRefreshLoading(true, true);

                this.RefreshCommand.Execute(dataLoadingComplete);
            }
        }
    }
}
